#pragma once

#include "ActorInterface.h"
#include "WASCommand.h"
#include "WASActor.h"

class CWASUpdateGroupSortOrder : public CWASCommand
{
public:
	CWASUpdateGroupSortOrder(CWASActor *pActor);
	~CWASUpdateGroupSortOrder(void);
	
	void ExecuteAsync(void);

	void SetParameter(std::vector<GT_BUDDY_GROUP_DATA> vecGroupData)
	{
		m_vecGroupData = vecGroupData;
	}


private:
	bool ParseAndEventFire(nfc::CIkXMLDom * pDom);

protected:
	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		nfc::CIkXMLDom * /*pDom*/);

	virtual void OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/);

private:

	vector<GT_BUDDY_GROUP_DATA> m_vecGroupData;

	int m_nGroupID;
	int m_nSortOrder;

	P_GT_BUDDY_GROUP_UPDATABLE_DATA m_sGroupInfo;

};
